#!/bin/bash

SERVER_ADDRESS="0.0.0.0"
CLIENT_ADDRESS="0.0.0.0"
SERVER_PORT="0"
CLIENT_PORT="0"
INTERFACES="0"
KEY="key"
IPTABLES="/sbin/iptables"
OPENVPN="/usr/sbin/openvpn"
MY_IP_PUBBLIC="0"

if [ ! -e $KEY ] 
then
	echo -e " Attenzione chiave non trovata.... \n Vuoi generarla ? ( s/N )"
	read answer
	if [ $answer = "s" ] || [ $answer = "S" ] || [ $answer = "y" ] || [ $answer = "Y" ]
	then
		echo "La chiave DEVE essere uguale lato client e lato server"
		echo "deve essere in questa dir ( se non modifichi questo file )"
		echo "e chiamarsi key"
		echo "Genero la chiave...."
		echo "Premi un tasto per continuare...."
		read
		$OPENVPN --genkey --secret key
		cat key
		echo "Chiave Generata..."	
	else 	echo "Non Funziono senza chiave.... "
		echo -e "\nGenera la chiave prima..."
		exit
	fi
fi

if [ $SERVER_ADDRESS = "0.0.0.0" ] 
then
	echo -e "\n\nDimmi l' indirizzo IP da usare nella VPN"
	echo "Se non vuoi che ti venga piu chiesto (ip fissi o porte fisse)"
	echo "modifica le prime linee dei questo files inserendo gli IP."
	echo -e "\n\nIP Server: "
	read answer
	SERVER_ADDRESS=$answer
	echo -e "\nIP Client: "
	read answer
	CLIENT_ADDRESS=$answer
	echo -e "\nDimmi l' interfaccia usata per il collegamento verso internet"
	echo "scelte... pppX   ethX"
	read answer
	INTERFACES=$answer
	echo -e "\nPorta da cui fare il forward: "
	read answer
	SERVER_PORT=$answer
	echo -e "\nPorta su cui fare il forward: "
	read answer
	CLIENT_PORT=$answer
fi
echo -e " Dimmi il tuo indirizzo esterno, verso internet "
read answer
MY_IP_PUBBLIC=$answer #`/sbin/ifconfig $INTERFACES | grep ine | cut -c21-32`" #Non funziona sempre
echo "Il mio ip sull'interfaccia $INTERFACES e' $MY_IP_PUBBLIC"
echo "\nAttivo il modulo Tun.... Si presume esso sia come modulo,"
echo "Nel caso sia compilato interno al kernel, ignorare il messaggio"
echo "di errore che comparir...."

/sbin/lsmod | grep tun 
if [ $? -eq 0 ]
then
	/sbin/modprobe tun
	/sbin/lsmod | grep tun
	if ! [ $? -eq 0 ]
	then
		echo "MODULO TUN NON TROVATO!!" 
		echo -e "\nSe il modulo  integrato nel kernel"
		echo "ignorare il messaggio di errore, altrimenti"
		echo "provvedere a caricarlo a mano...."
		read
	else echo "Modulo TUN caricato...."
	fi
else echo "Modulo tun gia' presente nel sistema...."
fi

echo -e "\nInizio configurazione Firewall...."
echo "ATTENZIONE!!!!!"
echo "Questo firewall funziona SOLO per il tunneling, NON GARANTISCE"
echo "ALCUNA SICUREZZA...."
echo -e "\n\nPremi un tasto per continuare...."
read

$IPTABLES -t nat -F
$IPTABLES -F INPUT
$IPTABLES -F OUTPUT
$IPTABLES -F FORWARD
$IPTABLES  -P INPUT ACCEPT
$IPTABLES  -P FORWARD ACCEPT
$IPTABLES  -P OUTPUT ACCEPT

${IPTABLES}  -t nat -A PREROUTING -p tcp -i $INTERFACES --dport $SERVER_PORT -j DNAT --to ${CLIENT_ADDRESS}:$CLIENT_PORT
${IPTABLES}  -t nat -A PREROUTING -p tcp -i ${INTERFACES} --dport 30000:65325 -j DNAT --to $CLIENT_ADDRESS

$IPTABLES  -t nat -A POSTROUTING -o $INTERFACES -s $CLIENT_ADDRESS -j MASQUERADE
$IPTABLES  -t nat -A POSTROUTING -o tun1 -p tcp -s $CLIENT_ADDRESS -j SNAT --to $MY_IP_PUBBLIC
$IPTABLES  -t nat -A POSTROUTING -o tun1 -j MASQUERADE
 
$IPTABLES  -A FORWARD -i tun1 -p tcp -j ACCEPT
$IPTABLES  -A FORWARD -i tun1 -p udp -j ACCEPT

$IPTABLES  -A INPUT -i tun1 -p tcp -j ACCEPT
$IPTABLES  -A INPUT -i tun1 -p udp -j ACCEPT
echo -e "\n\n\nStampo le regole del firewall"
$IPTABLES  -L
$IPTABLES  -t nat -L

# Abilito il forward
echo "1" > /proc/sys/net/ipv4/ip_forward

echo "Configurazione completata, premi un tanto per lanciare il demone openvpn"
echo "Per terminare CRTL+C"
read
# Lancio il server openvpn
$OPENVPN --dev tun1 --ifconfig $SERVER_ADDRESS $CLIENT_ADDRESS --verb 5 --secret $KEY
